/*
From frankcole.lvcm.com!fwc Sat Apr  3 21:39:32 1999
Return-Path: <fwc@frankcole.lvcm.com>
Received: from Prime-FE1.lvcablemodem.com(prime-fe1.lvcablemodem.com[24.234.0.9]) (8592 bytes) by mail.chemie.fu-berlin.de
	via sendmail with P:esmtp/D:user/T:local
	(sender: <fwc@frankcole.lvcm.com>) 
	id <m10TWGR-000FwFC@mail.chemie.fu-berlin.de>
	for <clausi@chemie.fu-berlin.de>; Sat, 3 Apr 1999 21:39:31 +0200 (CEST)
	(Smail-3.2.0.101 1997-Dec-17 #18 built 1999-Feb-17)
Received: from prime-fe1.lvcablemodem.com - 24.234.0.9 by lvcablemodem.com with Microsoft SMTPSVC;
	 Sat, 3 Apr 1999 11:43:27 -0800
Received: from  (dhcp025.52.lvcm.com [24.234.52.25]) by prime-fe1.lvcablemodem.com with SMTP (MailShield v1.5); Sat, 03 Apr 1999 11:43:26 -0800
Date: Sat, 3 Apr 1999 11:36:40 -0800 (PST)
From: Frank W Cole <fwc@frankcole.lvcm.com>
To: clausi@chemie.fu-berlin.de, gpib@listserv.llp.fu-berlin.de
Subject: Linux GPIB package
Message-ID: <Pine.LNX.3.96.990403112636.8596A-100000@frankcole.lvcm.com>
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII
Status: RO
X-Status: 


Mr Schroeter or whoever is handling this nowadays -

I downloaded your IEEE488 package a few weeks ago
(linux-gpib-2.0.24.base.tar.gz) and finally got to play with it. Got it
working fairly easily and used it to talk to a Hewlett-Packard 8563A
spectrum analyzer using an HP82335 controller card. "ibconf" worked so wrote
a small routine to control the instrument and dump data from the instrument.

I used the defaults supplied and added

device{
	name = analyzer
	pad = 18
	sad = 0
}

to 'gpib.conf'.

I commandeered your Makefile in the Examples directory to compile the
analyzer code after wondering where the '.h' and '.lib' files were. Beat
trying to take apart "ib.h" and finding everything.

I'm attaching the "analyzer.c" code below. Please keep in mind I'm not a
"real programmer", and you may want to be sitting down when you read it in
case you start laughing too hard. There is no warranty or support attached
to the code. I release it for whatever you wish to do with it.

I also have access to other types of test equipment, primarily radio
frequency stuff. That includes an HP 8566 spectrum analyzer, scalar
network analyzers, frequency counters, RF power meters, and
oscilloscopes. If you're interested I can send what results I get as I
get to them. Don't hold your breath waiting for anything, this is
strictly a spare-time project at work and time is difficult to find. 
Send a reply if you're interested.

I'm using the Slackware April 1997 release, kernel is 2.0.29. The machine is
a 200 MHz Pentium with PCI and ISA busses.

I thank you for the Linux GPIB package. I may get some real use out of it
down the road.

Frank W. Cole
Las Vegas, Nevada 89119
fwc@frankcole.lvcm.com

Code follows. I hope I didn't misspell or fat-finger the keyboard somewhere.
*/


/************************************************************************/

/*
This does some basic control and readback of a Hewlett-Packard 8563A
spectrum analyzer, using an HP82335 GPIB controller card.
*/

#include <stdio.h>
#include <stdlib.h>
#include <gpib/ib.h>

int main(void)
{

	char Command[4901]; 	/* Used for sending commands to the analyzer
				and reading back the data. The trace data
				length can be up to 4808 characters */

	int analyzer;

	/* Most data is put into floats, makes it easier to "crunch" the
	data later. */
	float Centerfreq;	/* center frequency */
	float Span;		/* span width */
	float RBW;		/* resolution bandwidth (IF bandwidth) */
	float VBW;		/* video bandwidth */
	float Referencelevel;	/* reference level at the top of the display
				*/
	float Perdivision;	/* dB per division on the display */
	float Sweeptime;	
	float Attenuator;	/* input attenuator setting */
	
	/* get device configuration (analyzer) */
	if((analyzer=ibfind("analyzer"))&ERR){
		printf("Can't find analyzer\n");
		exit(1);
	}
	
	/* do a full reset on the instrument to get a known state */
	strcpy(Command, "ip;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("Can't reset instrument\n");
		exit(1);
	}
	
	/* The spectrum analyzer cal signal is connected to the analyzer
	input, and the signal is at 300 MHz. This setup will display the
	signal so we have something to look at. */
	
	/* set the frequency span to 10 MHz */
	strcpy(Command, "sp 10e6hz;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("Can't set the span\n");
		exit(1);
	}
	
	/* set the center frequency to 300 MHz and force a sweep ('ts') to
	make sure we get good data */
	strcpy(Command, "cf 300e6hz;ts;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("Can't set the center frequency\n");
		exit(1);
	}
	
	/* now ask for the trace (screen) data */
	strcpy(Command, "tra?;"); /* several traces available - which
	one we want? */
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for trace data\n");
		exit(1);
	}
	
	/* read the data in */ 
	/* The data stream is variable length, up to 4808 characters. The
	data is in dBm, up to 7 characters in length and a comma (total 8)
	per datapoint. Looks like '-100.00,-87.15,-100,-86.8,' etc. There
	are 601 datapoints per trace. */
	if(ibrd(analyzer, Command, 4900)&ERR){
		printf("error reading trace data\n");
		exit(1);
	}
	/* Should pump this into a float array for crunching / graphing but
	ran out of time */
	
	/* just idle curiousity */
	printf("Data stream length = %d\n", strlen(Command));
	
	/* ask for the center frequency - nevermind I set it, wanted to try
	it out */
	strcpy(Command, "cf?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for center freq\n");
		exit(1);
	}
	
	/* read the center freq in */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading center freq\n");
		exit(1);
	}
	
	/* put the center freq in (float)Centerfreq */
	Centerfreq=atof(Command);
	printf("Center frequency = %f\n", Centerfreq);
	
	/* ask for the frequency span - again, set but what the hey? */
	strcpy(Command, "sp?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for freq span\n");
		exit(1);
	}
	
	/* read the freq span in */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading freq span\n");
		exit(1);
	}
	
	/* put the freq span in (float)Span */
	Span=atof(Command);
	printf("Frequency span = %f\n", Span);
	
	/* ask for the resolution bandwidth (IF bandwidth) */
	strcpy(Command, "rb?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for rbw\n");
		exit(1);
	}
	
	/* read the rbw in */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading rbw\n");
		exit(1);
	}
	
	/* put the rbw in (float)RBW */
	RBW=atof(Command);
	printf("Resolution bandwidth = %f\n", RBW);
	
	/* ask for the video bandwidth */
	strcpy(Command, "vb?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for vbw\n");
		exit(1);
	}
	
	/* read the vbw in */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading vbw\n");
		exit(1);
	}
	
	/* put the rbw in (float)VBW */
	VBW=atof(Command);
	printf("Video bandwidth = %f\n", VBW);
	
	/* ask for the reference level */
	strcpy(Command, "rl?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for rl\n");
		exit(1);
	}
	
	/* read the reference level in */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading rl\n");
		exit(1);
	}
	
	/* put the reference level in (float)Referencelevel */
	Referencelevel=atof(Command);
	printf("Reference level = %f\n", Referencelevel);
	
	/* ask for the per division scale value */
	strcpy(Command, "lg?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for per division\n");
		exit(1);
	}
	
	/* read the per division value */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading per division\n");
		exit(1);
	}
	
	/* put the per division value in (float)Perdivision */
	Perdivision=atof(Command);
	printf("Per division value = %f\n", Perdivision);
	
	/* ask for the sweep time */
	strcpy(Command, "st?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for sweep time\n");
		exit(1);
	}
	
	/* read the sweep time */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading sweep time\n");
		exit(1);
	}
	
	/* put the sweep time in (float)Sweeptime */
	Sweeptime=atof(Command);
	printf("Sweep time = %f\n", Sweeptime);
	
	/* ask for the input attenuator setting */
	strcpy(Command, "at?;");
	if(ibwrt(analyzer, Command, strlen(Command))&ERR){
		printf("error asking for attenuator setting\n");
		exit(1);
	}
	
	/* read the attenuator setting */
	if(ibrd(analyzer, Command, 20)&ERR){
		printf("error reading attenuator\n");
		exit(1);
	}
	
	/* put the input attenuator setting in (float)Attenuator */
	Attenuator=atof(Command);
	printf("Input attenuator setting = %f\n", Attenuator);
	
	exit(0);

} 




