/** 
 *   Site testing for SKA candidate.
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 **/

#ifndef _OBSERV_TABLR_H
#define _OBSERV_TABLR_H

#include <time.h>

struct observ {
	int mode;
	double start_freq;
	double stop_freq;
	int RBW;
	int sweep;
	int repetitions;
	char switchs;
	struct observ *next;
};


struct obs_setup {
	time_t start;
	char *data_dir;
	int pos;
	char pol;
	int mode;
	int current_rep;
	double *data;
	struct observ *obs;
};


struct observ *get_observ_table(char *file_name);
int free_observ_table(struct observ *obs);

#endif /* ifndef _OBSERV_TABLR_H */
