/** 
 *   Site testing for SKA candidate.
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO:
 *        *) Data save.
 *        *)
 *
 *
 **/

#define _GNU_SOURCE

#include <stdio.h>
#include <unistd.h>
#include <time.h>

#include "observ_table.h"
#include "analyzer.h"


int save_observ(struct obs_setup *s)
{
	char file[160];
	struct tm *t;

/* 

   s2004112617401030h00959999011000004418

*/


	t = localtime(&s->start);
	sprintf(file,"%s/s%04d%02d%02d%02d%02d%1d%03d%c%08d%08d%02d%02d",
		s->data_dir,
		t->tm_year + 1900, t->tm_mon+1, t->tm_mday,
		t->tm_hour, t->tm_min,
		s->mode, s->pos, s->pol,
		(int)(s->obs->start_freq * 1000000),
		(int)(s->obs->stop_freq * 1000000),
		s->obs->repetitions, s->current_rep);

	printf("%s\n", file);

	return 0;
	
}


int get_observ( int dev, struct obs_setup *s)
{
	int ret;
	int i = 0;

	
	while (analyzer_get_observ( dev, s) != 0) {
		
		if ((ret = analyzer_reset(dev)) != 0){
		  if (i < AN_RETRY_TIME_OUT) {
		    sleep(1);
		    i++;
		  }
		  else
		    return ret;
		}
	}
	save_observ(s);
	
	return 0;
}


int observ_mode(int dev, struct obs_setup *s)
{
	struct observ *obsp = s->obs;
	int i, error;
	while (obsp != NULL) {
		if (obsp->mode == s->mode) {
			for(i = 0; i < obsp->repetitions; i++){
				s->current_rep = i+1;
				s->obs = obsp;
				error = get_observ( dev, s);
				if (error) {
					return error;
				}
			}
		}
		obsp = obsp->next;
	}

	return 0;
}
